Index: /branches/UKMO/dev_r4650_general_vert_coord_obsoper/NEMOGCM/NEMO/OPA_SRC/OBS/obs_oper.F90
===================================================================
--- /branches/UKMO/dev_r4650_general_vert_coord_obsoper/NEMOGCM/NEMO/OPA_SRC/OBS/obs_oper.F90	(revision 7712)
+++ /branches/UKMO/dev_r4650_general_vert_coord_obsoper/NEMOGCM/NEMO/OPA_SRC/OBS/obs_oper.F90	(revision 7713)
@@ -23,4 +23,12 @@
    !!   obs_vel_opt :    Compute the model counterpart of zonal and meridional
    !!                    components of velocity from observations.
+   !!   obs_logchl_opt : Compute the model counterpart of log10(chlorophyll)
+   !!                    observations
+   !!   obs_spm_opt :    Compute the model counterpart of spm
+   !!                    observations
+   !!   obs_fco2_opt :   Compute the model counterpart of fco2
+   !!                    observations
+   !!   obs_pco2_opt :   Compute the model counterpart of pco2
+   !!                    observations
    !!----------------------------------------------------------------------
 
@@ -63,5 +71,9 @@
       &   obs_sss_opt, &  ! Compute the model counterpart of SSS observations
       &   obs_seaice_opt, &
-      &   obs_vel_opt     ! Compute the model counterpart of velocity profile data
+      &   obs_vel_opt, &  ! Compute the model counterpart of velocity profile data
+      &   obs_logchl_opt, & ! Compute the model counterpart of logchl data
+      &   obs_spm_opt, &  ! Compute the model counterpart of spm data
+      &   obs_fco2_opt, & ! Compute the model counterpart of fco2 data
+      &   obs_pco2_opt    ! Compute the model counterpart of pco2 data
 
    INTEGER, PARAMETER, PUBLIC :: imaxavtypes = 20 ! Max number of daily avgd obs types
@@ -2052,4 +2064,644 @@
    END SUBROUTINE obs_vel_opt
 
+   SUBROUTINE obs_logchl_opt( logchldatqc, kt, kpi, kpj, kit000, &
+      &                    plogchln, plogchlmask, k2dint )
+
+      !!-----------------------------------------------------------------------
+      !!
+      !!                     ***  ROUTINE obs_logchl_opt  ***
+      !!
+      !! ** Purpose : Compute the model counterpart of logchl
+      !!              data by interpolating from the model grid to the 
+      !!              observation point.
+      !!
+      !! ** Method  : Linearly interpolate to each observation point using 
+      !!              the model values at the corners of the surrounding grid box.
+      !!
+      !!    The now model logchl is first computed at the obs (lon, lat) point.
+      !!
+      !!    Several horizontal interpolation schemes are available:
+      !!        - distance-weighted (great circle) (k2dint = 0)
+      !!        - distance-weighted (small angle)  (k2dint = 1)
+      !!        - bilinear (geographical grid)     (k2dint = 2)
+      !!        - bilinear (quadrilateral grid)    (k2dint = 3)
+      !!        - polynomial (quadrilateral grid)  (k2dint = 4)
+      !!
+      !!
+      !! ** Action  :
+      !!
+      !! History :
+      !!      
+      !!-----------------------------------------------------------------------
+
+      !! * Modules used
+      USE obs_surf_def  ! Definition of storage space for surface observations
+
+      IMPLICIT NONE
+
+      !! * Arguments
+      TYPE(obs_surf), INTENT(INOUT) :: logchldatqc     ! Subset of surface data not failing screening
+      INTEGER, INTENT(IN) :: kt       ! Time step
+      INTEGER, INTENT(IN) :: kpi      ! Model grid parameters
+      INTEGER, INTENT(IN) :: kpj
+      INTEGER, INTENT(IN) :: kit000   ! Number of the first time step 
+                                      !   (kit000-1 = restart time)
+      INTEGER, INTENT(IN) :: k2dint   ! Horizontal interpolation type (see header)
+      REAL(KIND=wp), INTENT(IN), DIMENSION(kpi,kpj) :: &
+         & plogchln,  &    ! Model logchl field
+         & plogchlmask     ! Land-sea mask
+         
+      !! * Local declarations
+      INTEGER :: ji
+      INTEGER :: jj
+      INTEGER :: jobs
+      INTEGER :: inrc
+      INTEGER :: ilogchl
+      INTEGER :: iobs
+       
+      REAL(KIND=wp) :: zlam
+      REAL(KIND=wp) :: zphi
+      REAL(KIND=wp) :: zext(1), zobsmask(1)
+      REAL(kind=wp), DIMENSION(2,2,1) :: &
+         & zweig
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: &
+         & zmask, &
+         & zlogchll, &
+         & zglam, &
+         & zgphi
+      INTEGER, DIMENSION(:,:,:), ALLOCATABLE :: &
+         & igrdi, &
+         & igrdj
+
+      !------------------------------------------------------------------------
+      ! Local initialization 
+      !------------------------------------------------------------------------
+      ! ... Record and data counters
+      inrc = kt - kit000 + 2
+      ilogchl = logchldatqc%nsstp(inrc)
+
+      ! Get the data for interpolation
+      
+      ALLOCATE( &
+         & igrdi(2,2,ilogchl), &
+         & igrdj(2,2,ilogchl), &
+         & zglam(2,2,ilogchl), &
+         & zgphi(2,2,ilogchl), &
+         & zmask(2,2,ilogchl), &
+         & zlogchll(2,2,ilogchl)  &
+         & )
+      
+      DO jobs = logchldatqc%nsurfup + 1, logchldatqc%nsurfup + ilogchl
+         iobs = jobs - logchldatqc%nsurfup
+         igrdi(1,1,iobs) = logchldatqc%mi(jobs)-1
+         igrdj(1,1,iobs) = logchldatqc%mj(jobs)-1
+         igrdi(1,2,iobs) = logchldatqc%mi(jobs)-1
+         igrdj(1,2,iobs) = logchldatqc%mj(jobs)
+         igrdi(2,1,iobs) = logchldatqc%mi(jobs)
+         igrdj(2,1,iobs) = logchldatqc%mj(jobs)-1
+         igrdi(2,2,iobs) = logchldatqc%mi(jobs)
+         igrdj(2,2,iobs) = logchldatqc%mj(jobs)
+      END DO
+      
+      CALL obs_int_comm_2d( 2, 2, ilogchl, &
+         &                  igrdi, igrdj, glamt, zglam )
+      CALL obs_int_comm_2d( 2, 2, ilogchl, &
+         &                  igrdi, igrdj, gphit, zgphi )
+      CALL obs_int_comm_2d( 2, 2, ilogchl, &
+         &                  igrdi, igrdj, plogchlmask, zmask )
+      CALL obs_int_comm_2d( 2, 2, ilogchl, &
+         &                  igrdi, igrdj, plogchln, zlogchll )
+      
+      DO jobs = logchldatqc%nsurfup + 1, logchldatqc%nsurfup + ilogchl
+         
+         iobs = jobs - logchldatqc%nsurfup
+         
+         IF ( kt /= logchldatqc%mstp(jobs) ) THEN
+            
+            IF(lwp) THEN
+               WRITE(numout,*)
+               WRITE(numout,*) ' E R R O R : Observation',              &
+                  &            ' time step is not consistent with the', &
+                  &            ' model time step'
+               WRITE(numout,*) ' ========='
+               WRITE(numout,*)
+               WRITE(numout,*) ' Record  = ', jobs,                &
+                  &            ' kt      = ', kt,                  &
+                  &            ' mstp    = ', logchldatqc%mstp(jobs), &
+                  &            ' ntyp    = ', logchldatqc%ntyp(jobs)
+            ENDIF
+            CALL ctl_stop( 'obs_logchl_opt', 'Inconsistent time' )
+            
+         ENDIF
+         
+         zlam = logchldatqc%rlam(jobs)
+         zphi = logchldatqc%rphi(jobs)
+         
+         ! Get weights to interpolate the model logchl to the observation point
+         CALL obs_int_h2d_init( 1, 1, k2dint, zlam, zphi,         &
+            &                   zglam(:,:,iobs), zgphi(:,:,iobs), &
+            &                   zmask(:,:,iobs), zweig, zobsmask )
+         
+         ! ... Interpolate the model logchl to the observation point
+         CALL obs_int_h2d( 1, 1,      &
+            &              zweig, zlogchll(:,:,iobs),  zext )
+         
+         logchldatqc%rmod(jobs,1) = zext(1)
+         
+      END DO
+      
+      ! Deallocate the data for interpolation
+      DEALLOCATE( &
+         & igrdi,    &
+         & igrdj,    &
+         & zglam,    &
+         & zgphi,    &
+         & zmask,    &
+         & zlogchll  &
+         & )
+      
+      logchldatqc%nsurfup = logchldatqc%nsurfup + ilogchl
+
+   END SUBROUTINE obs_logchl_opt
+
+   SUBROUTINE obs_spm_opt( spmdatqc, kt, kpi, kpj, kit000, &
+      &                    pspmn, pspmmask, k2dint )
+
+      !!-----------------------------------------------------------------------
+      !!
+      !!                     ***  ROUTINE obs_spm_opt  ***
+      !!
+      !! ** Purpose : Compute the model counterpart of spm
+      !!              data by interpolating from the model grid to the 
+      !!              observation point.
+      !!
+      !! ** Method  : Linearly interpolate to each observation point using 
+      !!              the model values at the corners of the surrounding grid box.
+      !!
+      !!    The now model spm is first computed at the obs (lon, lat) point.
+      !!
+      !!    Several horizontal interpolation schemes are available:
+      !!        - distance-weighted (great circle) (k2dint = 0)
+      !!        - distance-weighted (small angle)  (k2dint = 1)
+      !!        - bilinear (geographical grid)     (k2dint = 2)
+      !!        - bilinear (quadrilateral grid)    (k2dint = 3)
+      !!        - polynomial (quadrilateral grid)  (k2dint = 4)
+      !!
+      !!
+      !! ** Action  :
+      !!
+      !! History :
+      !!      
+      !!-----------------------------------------------------------------------
+
+      !! * Modules used
+      USE obs_surf_def  ! Definition of storage space for surface observations
+
+      IMPLICIT NONE
+
+      !! * Arguments
+      TYPE(obs_surf), INTENT(INOUT) :: spmdatqc     ! Subset of surface data not failing screening
+      INTEGER, INTENT(IN) :: kt       ! Time step
+      INTEGER, INTENT(IN) :: kpi      ! Model grid parameters
+      INTEGER, INTENT(IN) :: kpj
+      INTEGER, INTENT(IN) :: kit000   ! Number of the first time step 
+                                      !   (kit000-1 = restart time)
+      INTEGER, INTENT(IN) :: k2dint   ! Horizontal interpolation type (see header)
+      REAL(KIND=wp), INTENT(IN), DIMENSION(kpi,kpj) :: &
+         & pspmn,  &    ! Model spm field
+         & pspmmask     ! Land-sea mask
+         
+      !! * Local declarations
+      INTEGER :: ji
+      INTEGER :: jj
+      INTEGER :: jobs
+      INTEGER :: inrc
+      INTEGER :: ispm
+      INTEGER :: iobs
+       
+      REAL(KIND=wp) :: zlam
+      REAL(KIND=wp) :: zphi
+      REAL(KIND=wp) :: zext(1), zobsmask(1)
+      REAL(kind=wp), DIMENSION(2,2,1) :: &
+         & zweig
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: &
+         & zmask, &
+         & zspml, &
+         & zglam, &
+         & zgphi
+      INTEGER, DIMENSION(:,:,:), ALLOCATABLE :: &
+         & igrdi, &
+         & igrdj
+
+      !------------------------------------------------------------------------
+      ! Local initialization 
+      !------------------------------------------------------------------------
+      ! ... Record and data counters
+      inrc = kt - kit000 + 2
+      ispm = spmdatqc%nsstp(inrc)
+
+      ! Get the data for interpolation
+      
+      ALLOCATE( &
+         & igrdi(2,2,ispm), &
+         & igrdj(2,2,ispm), &
+         & zglam(2,2,ispm), &
+         & zgphi(2,2,ispm), &
+         & zmask(2,2,ispm), &
+         & zspml(2,2,ispm)  &
+         & )
+      
+      DO jobs = spmdatqc%nsurfup + 1, spmdatqc%nsurfup + ispm
+         iobs = jobs - spmdatqc%nsurfup
+         igrdi(1,1,iobs) = spmdatqc%mi(jobs)-1
+         igrdj(1,1,iobs) = spmdatqc%mj(jobs)-1
+         igrdi(1,2,iobs) = spmdatqc%mi(jobs)-1
+         igrdj(1,2,iobs) = spmdatqc%mj(jobs)
+         igrdi(2,1,iobs) = spmdatqc%mi(jobs)
+         igrdj(2,1,iobs) = spmdatqc%mj(jobs)-1
+         igrdi(2,2,iobs) = spmdatqc%mi(jobs)
+         igrdj(2,2,iobs) = spmdatqc%mj(jobs)
+      END DO
+      
+      CALL obs_int_comm_2d( 2, 2, ispm, &
+         &                  igrdi, igrdj, glamt, zglam )
+      CALL obs_int_comm_2d( 2, 2, ispm, &
+         &                  igrdi, igrdj, gphit, zgphi )
+      CALL obs_int_comm_2d( 2, 2, ispm, &
+         &                  igrdi, igrdj, pspmmask, zmask )
+      CALL obs_int_comm_2d( 2, 2, ispm, &
+         &                  igrdi, igrdj, pspmn, zspml )
+      
+      DO jobs = spmdatqc%nsurfup + 1, spmdatqc%nsurfup + ispm
+         
+         iobs = jobs - spmdatqc%nsurfup
+         
+         IF ( kt /= spmdatqc%mstp(jobs) ) THEN
+            
+            IF(lwp) THEN
+               WRITE(numout,*)
+               WRITE(numout,*) ' E R R O R : Observation',              &
+                  &            ' time step is not consistent with the', &
+                  &            ' model time step'
+               WRITE(numout,*) ' ========='
+               WRITE(numout,*)
+               WRITE(numout,*) ' Record  = ', jobs,                &
+                  &            ' kt      = ', kt,                  &
+                  &            ' mstp    = ', spmdatqc%mstp(jobs), &
+                  &            ' ntyp    = ', spmdatqc%ntyp(jobs)
+            ENDIF
+            CALL ctl_stop( 'obs_spm_opt', 'Inconsistent time' )
+            
+         ENDIF
+         
+         zlam = spmdatqc%rlam(jobs)
+         zphi = spmdatqc%rphi(jobs)
+         
+         ! Get weights to interpolate the model spm to the observation point
+         CALL obs_int_h2d_init( 1, 1, k2dint, zlam, zphi,         &
+            &                   zglam(:,:,iobs), zgphi(:,:,iobs), &
+            &                   zmask(:,:,iobs), zweig, zobsmask )
+         
+         ! ... Interpolate the model spm to the observation point
+         CALL obs_int_h2d( 1, 1,      &
+            &              zweig, zspml(:,:,iobs),  zext )
+         
+         spmdatqc%rmod(jobs,1) = zext(1)
+         
+      END DO
+      
+      ! Deallocate the data for interpolation
+      DEALLOCATE( &
+         & igrdi,    &
+         & igrdj,    &
+         & zglam,    &
+         & zgphi,    &
+         & zmask,    &
+         & zspml  &
+         & )
+      
+      spmdatqc%nsurfup = spmdatqc%nsurfup + ispm
+
+   END SUBROUTINE obs_spm_opt
+
+   SUBROUTINE obs_fco2_opt( fco2datqc, kt, kpi, kpj, kit000, &
+      &                    pfco2n, pfco2mask, k2dint )
+
+      !!-----------------------------------------------------------------------
+      !!
+      !!                     ***  ROUTINE obs_fco2_opt  ***
+      !!
+      !! ** Purpose : Compute the model counterpart of fco2
+      !!              data by interpolating from the model grid to the 
+      !!              observation point.
+      !!
+      !! ** Method  : Linearly interpolate to each observation point using 
+      !!              the model values at the corners of the surrounding grid box.
+      !!
+      !!    The now model fco2 is first computed at the obs (lon, lat) point.
+      !!
+      !!    Several horizontal interpolation schemes are available:
+      !!        - distance-weighted (great circle) (k2dint = 0)
+      !!        - distance-weighted (small angle)  (k2dint = 1)
+      !!        - bilinear (geographical grid)     (k2dint = 2)
+      !!        - bilinear (quadrilateral grid)    (k2dint = 3)
+      !!        - polynomial (quadrilateral grid)  (k2dint = 4)
+      !!
+      !!
+      !! ** Action  :
+      !!
+      !! History :
+      !!      
+      !!-----------------------------------------------------------------------
+
+      !! * Modules used
+      USE obs_surf_def  ! Definition of storage space for surface observations
+
+      IMPLICIT NONE
+
+      !! * Arguments
+      TYPE(obs_surf), INTENT(INOUT) :: fco2datqc     ! Subset of surface data not failing screening
+      INTEGER, INTENT(IN) :: kt       ! Time step
+      INTEGER, INTENT(IN) :: kpi      ! Model grid parameters
+      INTEGER, INTENT(IN) :: kpj
+      INTEGER, INTENT(IN) :: kit000   ! Number of the first time step 
+                                      !   (kit000-1 = restart time)
+      INTEGER, INTENT(IN) :: k2dint   ! Horizontal interpolation type (see header)
+      REAL(KIND=wp), INTENT(IN), DIMENSION(kpi,kpj) :: &
+         & pfco2n,  &    ! Model fco2 field
+         & pfco2mask     ! Land-sea mask
+         
+      !! * Local declarations
+      INTEGER :: ji
+      INTEGER :: jj
+      INTEGER :: jobs
+      INTEGER :: inrc
+      INTEGER :: ifco2
+      INTEGER :: iobs
+       
+      REAL(KIND=wp) :: zlam
+      REAL(KIND=wp) :: zphi
+      REAL(KIND=wp) :: zext(1), zobsmask(1)
+      REAL(kind=wp), DIMENSION(2,2,1) :: &
+         & zweig
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: &
+         & zmask, &
+         & zfco2l, &
+         & zglam, &
+         & zgphi
+      INTEGER, DIMENSION(:,:,:), ALLOCATABLE :: &
+         & igrdi, &
+         & igrdj
+
+      !------------------------------------------------------------------------
+      ! Local initialization 
+      !------------------------------------------------------------------------
+      ! ... Record and data counters
+      inrc = kt - kit000 + 2
+      ifco2 = fco2datqc%nsstp(inrc)
+
+      ! Get the data for interpolation
+      
+      ALLOCATE( &
+         & igrdi(2,2,ifco2), &
+         & igrdj(2,2,ifco2), &
+         & zglam(2,2,ifco2), &
+         & zgphi(2,2,ifco2), &
+         & zmask(2,2,ifco2), &
+         & zfco2l(2,2,ifco2)  &
+         & )
+      
+      DO jobs = fco2datqc%nsurfup + 1, fco2datqc%nsurfup + ifco2
+         iobs = jobs - fco2datqc%nsurfup
+         igrdi(1,1,iobs) = fco2datqc%mi(jobs)-1
+         igrdj(1,1,iobs) = fco2datqc%mj(jobs)-1
+         igrdi(1,2,iobs) = fco2datqc%mi(jobs)-1
+         igrdj(1,2,iobs) = fco2datqc%mj(jobs)
+         igrdi(2,1,iobs) = fco2datqc%mi(jobs)
+         igrdj(2,1,iobs) = fco2datqc%mj(jobs)-1
+         igrdi(2,2,iobs) = fco2datqc%mi(jobs)
+         igrdj(2,2,iobs) = fco2datqc%mj(jobs)
+      END DO
+      
+      CALL obs_int_comm_2d( 2, 2, ifco2, &
+         &                  igrdi, igrdj, glamt, zglam )
+      CALL obs_int_comm_2d( 2, 2, ifco2, &
+         &                  igrdi, igrdj, gphit, zgphi )
+      CALL obs_int_comm_2d( 2, 2, ifco2, &
+         &                  igrdi, igrdj, pfco2mask, zmask )
+      CALL obs_int_comm_2d( 2, 2, ifco2, &
+         &                  igrdi, igrdj, pfco2n, zfco2l )
+      
+      DO jobs = fco2datqc%nsurfup + 1, fco2datqc%nsurfup + ifco2
+         
+         iobs = jobs - fco2datqc%nsurfup
+         
+         IF ( kt /= fco2datqc%mstp(jobs) ) THEN
+            
+            IF(lwp) THEN
+               WRITE(numout,*)
+               WRITE(numout,*) ' E R R O R : Observation',              &
+                  &            ' time step is not consistent with the', &
+                  &            ' model time step'
+               WRITE(numout,*) ' ========='
+               WRITE(numout,*)
+               WRITE(numout,*) ' Record  = ', jobs,                &
+                  &            ' kt      = ', kt,                  &
+                  &            ' mstp    = ', fco2datqc%mstp(jobs), &
+                  &            ' ntyp    = ', fco2datqc%ntyp(jobs)
+            ENDIF
+            CALL ctl_stop( 'obs_fco2_opt', 'Inconsistent time' )
+            
+         ENDIF
+         
+         zlam = fco2datqc%rlam(jobs)
+         zphi = fco2datqc%rphi(jobs)
+         
+         ! Get weights to interpolate the model fco2 to the observation point
+         CALL obs_int_h2d_init( 1, 1, k2dint, zlam, zphi,         &
+            &                   zglam(:,:,iobs), zgphi(:,:,iobs), &
+            &                   zmask(:,:,iobs), zweig, zobsmask )
+         
+         ! ... Interpolate the model fco2 to the observation point
+         CALL obs_int_h2d( 1, 1,      &
+            &              zweig, zfco2l(:,:,iobs),  zext )
+         
+         fco2datqc%rmod(jobs,1) = zext(1)
+         
+      END DO
+      
+      ! Deallocate the data for interpolation
+      DEALLOCATE( &
+         & igrdi,    &
+         & igrdj,    &
+         & zglam,    &
+         & zgphi,    &
+         & zmask,    &
+         & zfco2l  &
+         & )
+      
+      fco2datqc%nsurfup = fco2datqc%nsurfup + ifco2
+
+   END SUBROUTINE obs_fco2_opt
+
+   SUBROUTINE obs_pco2_opt( pco2datqc, kt, kpi, kpj, kit000, &
+      &                    ppco2n, ppco2mask, k2dint )
+
+      !!-----------------------------------------------------------------------
+      !!
+      !!                     ***  ROUTINE obs_pco2_opt  ***
+      !!
+      !! ** Purpose : Compute the model counterpart of pco2
+      !!              data by interpolating from the model grid to the 
+      !!              observation point.
+      !!
+      !! ** Method  : Linearly interpolate to each observation point using 
+      !!              the model values at the corners of the surrounding grid box.
+      !!
+      !!    The now model pco2 is first computed at the obs (lon, lat) point.
+      !!
+      !!    Several horizontal interpolation schemes are available:
+      !!        - distance-weighted (great circle) (k2dint = 0)
+      !!        - distance-weighted (small angle)  (k2dint = 1)
+      !!        - bilinear (geographical grid)     (k2dint = 2)
+      !!        - bilinear (quadrilateral grid)    (k2dint = 3)
+      !!        - polynomial (quadrilateral grid)  (k2dint = 4)
+      !!
+      !!
+      !! ** Action  :
+      !!
+      !! History :
+      !!      
+      !!-----------------------------------------------------------------------
+
+      !! * Modules used
+      USE obs_surf_def  ! Definition of storage space for surface observations
+
+      IMPLICIT NONE
+
+      !! * Arguments
+      TYPE(obs_surf), INTENT(INOUT) :: pco2datqc     ! Subset of surface data not failing screening
+      INTEGER, INTENT(IN) :: kt       ! Time step
+      INTEGER, INTENT(IN) :: kpi      ! Model grid parameters
+      INTEGER, INTENT(IN) :: kpj
+      INTEGER, INTENT(IN) :: kit000   ! Number of the first time step 
+                                      !   (kit000-1 = restart time)
+      INTEGER, INTENT(IN) :: k2dint   ! Horizontal interpolation type (see header)
+      REAL(KIND=wp), INTENT(IN), DIMENSION(kpi,kpj) :: &
+         & ppco2n,  &    ! Model pco2 field
+         & ppco2mask     ! Land-sea mask
+         
+      !! * Local declarations
+      INTEGER :: ji
+      INTEGER :: jj
+      INTEGER :: jobs
+      INTEGER :: inrc
+      INTEGER :: ipco2
+      INTEGER :: iobs
+       
+      REAL(KIND=wp) :: zlam
+      REAL(KIND=wp) :: zphi
+      REAL(KIND=wp) :: zext(1), zobsmask(1)
+      REAL(kind=wp), DIMENSION(2,2,1) :: &
+         & zweig
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: &
+         & zmask, &
+         & zpco2l, &
+         & zglam, &
+         & zgphi
+      INTEGER, DIMENSION(:,:,:), ALLOCATABLE :: &
+         & igrdi, &
+         & igrdj
+
+      !------------------------------------------------------------------------
+      ! Local initialization 
+      !------------------------------------------------------------------------
+      ! ... Record and data counters
+      inrc = kt - kit000 + 2
+      ipco2 = pco2datqc%nsstp(inrc)
+
+      ! Get the data for interpolation
+      
+      ALLOCATE( &
+         & igrdi(2,2,ipco2), &
+         & igrdj(2,2,ipco2), &
+         & zglam(2,2,ipco2), &
+         & zgphi(2,2,ipco2), &
+         & zmask(2,2,ipco2), &
+         & zpco2l(2,2,ipco2)  &
+         & )
+      
+      DO jobs = pco2datqc%nsurfup + 1, pco2datqc%nsurfup + ipco2
+         iobs = jobs - pco2datqc%nsurfup
+         igrdi(1,1,iobs) = pco2datqc%mi(jobs)-1
+         igrdj(1,1,iobs) = pco2datqc%mj(jobs)-1
+         igrdi(1,2,iobs) = pco2datqc%mi(jobs)-1
+         igrdj(1,2,iobs) = pco2datqc%mj(jobs)
+         igrdi(2,1,iobs) = pco2datqc%mi(jobs)
+         igrdj(2,1,iobs) = pco2datqc%mj(jobs)-1
+         igrdi(2,2,iobs) = pco2datqc%mi(jobs)
+         igrdj(2,2,iobs) = pco2datqc%mj(jobs)
+      END DO
+      
+      CALL obs_int_comm_2d( 2, 2, ipco2, &
+         &                  igrdi, igrdj, glamt, zglam )
+      CALL obs_int_comm_2d( 2, 2, ipco2, &
+         &                  igrdi, igrdj, gphit, zgphi )
+      CALL obs_int_comm_2d( 2, 2, ipco2, &
+         &                  igrdi, igrdj, ppco2mask, zmask )
+      CALL obs_int_comm_2d( 2, 2, ipco2, &
+         &                  igrdi, igrdj, ppco2n, zpco2l )
+      
+      DO jobs = pco2datqc%nsurfup + 1, pco2datqc%nsurfup + ipco2
+         
+         iobs = jobs - pco2datqc%nsurfup
+         
+         IF ( kt /= pco2datqc%mstp(jobs) ) THEN
+            
+            IF(lwp) THEN
+               WRITE(numout,*)
+               WRITE(numout,*) ' E R R O R : Observation',              &
+                  &            ' time step is not consistent with the', &
+                  &            ' model time step'
+               WRITE(numout,*) ' ========='
+               WRITE(numout,*)
+               WRITE(numout,*) ' Record  = ', jobs,                &
+                  &            ' kt      = ', kt,                  &
+                  &            ' mstp    = ', pco2datqc%mstp(jobs), &
+                  &            ' ntyp    = ', pco2datqc%ntyp(jobs)
+            ENDIF
+            CALL ctl_stop( 'obs_pco2_opt', 'Inconsistent time' )
+            
+         ENDIF
+         
+         zlam = pco2datqc%rlam(jobs)
+         zphi = pco2datqc%rphi(jobs)
+         
+         ! Get weights to interpolate the model pco2 to the observation point
+         CALL obs_int_h2d_init( 1, 1, k2dint, zlam, zphi,         &
+            &                   zglam(:,:,iobs), zgphi(:,:,iobs), &
+            &                   zmask(:,:,iobs), zweig, zobsmask )
+         
+         ! ... Interpolate the model pco2 to the observation point
+         CALL obs_int_h2d( 1, 1,      &
+            &              zweig, zpco2l(:,:,iobs),  zext )
+         
+         pco2datqc%rmod(jobs,1) = zext(1)
+         
+      END DO
+      
+      ! Deallocate the data for interpolation
+      DEALLOCATE( &
+         & igrdi,    &
+         & igrdj,    &
+         & zglam,    &
+         & zgphi,    &
+         & zmask,    &
+         & zpco2l  &
+         & )
+      
+      pco2datqc%nsurfup = pco2datqc%nsurfup + ipco2
+
+   END SUBROUTINE obs_pco2_opt
+
 END MODULE obs_oper
 
Index: /branches/UKMO/dev_r4650_general_vert_coord_obsoper/NEMOGCM/NEMO/OPA_SRC/OBS/obs_pco2.F90
===================================================================
--- /branches/UKMO/dev_r4650_general_vert_coord_obsoper/NEMOGCM/NEMO/OPA_SRC/OBS/obs_pco2.F90	(revision 7713)
+++ /branches/UKMO/dev_r4650_general_vert_coord_obsoper/NEMOGCM/NEMO/OPA_SRC/OBS/obs_pco2.F90	(revision 7713)
@@ -0,0 +1,35 @@
+MODULE obs_pco2
+   !!=====================================================================
+   !!                       ***  MODULE  obs_pco2  ***
+   !! Observation diagnostics: Storage space for pco2 observations
+   !!                          arrays and additional flags etc.
+   !!=====================================================================
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! $Id$
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+   
+   !! * Modules used 
+   USE obs_surf_def ! Definition of surface data types and tools
+
+   IMPLICIT NONE
+   
+   SAVE
+
+   !! * Routine accessibility
+   PRIVATE
+
+   PUBLIC npco2vars, npco2extr, npco2sets, pco2data, pco2datqc
+
+   !! * Shared Module variables
+   INTEGER :: npco2vars                               ! Number of pco2data variables
+   INTEGER :: npco2extr                               ! Number of pco2data extra 
+                                                      ! variables
+   INTEGER :: npco2sets                               ! Number of pco2data sets
+   TYPE(obs_surf), POINTER, DIMENSION(:) :: pco2data  ! Initial pco2 data
+   TYPE(obs_surf), POINTER, DIMENSION(:) :: pco2datqc ! Sea ice data after quality control
+
+END MODULE obs_pco2
+
Index: /branches/UKMO/dev_r4650_general_vert_coord_obsoper/NEMOGCM/NEMO/OPA_SRC/OBS/obs_pco2_io.F90
===================================================================
--- /branches/UKMO/dev_r4650_general_vert_coord_obsoper/NEMOGCM/NEMO/OPA_SRC/OBS/obs_pco2_io.F90	(revision 7713)
+++ /branches/UKMO/dev_r4650_general_vert_coord_obsoper/NEMOGCM/NEMO/OPA_SRC/OBS/obs_pco2_io.F90	(revision 7713)
@@ -0,0 +1,30 @@
+MODULE obs_pco2_io
+   !!======================================================================
+   !!                       ***  MODULE obs_pco2_io  ***
+   !! Observation operators : I/O for pco2 files
+   !!======================================================================
+   !! History : 
+   !!             !  09-01  (K. Mogensen) Initial version
+   !!----------------------------------------------------------------------
+   !!----------------------------------------------------------------------
+   !!   read_pco2file    :  Read a obfbdata structure from a pco2 file
+   !!----------------------------------------------------------------------
+   USE par_kind
+   USE obs_utils
+   USE obs_fbm
+   USE julian
+   USE netcdf
+
+   IMPLICIT NONE
+
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! $Id$
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+CONTAINS
+
+#include "obspco2_io.h90"
+
+END MODULE obs_pco2_io
Index: /branches/UKMO/dev_r4650_general_vert_coord_obsoper/NEMOGCM/NEMO/OPA_SRC/OBS/obs_prep.F90
===================================================================
--- /branches/UKMO/dev_r4650_general_vert_coord_obsoper/NEMOGCM/NEMO/OPA_SRC/OBS/obs_prep.F90	(revision 7712)
+++ /branches/UKMO/dev_r4650_general_vert_coord_obsoper/NEMOGCM/NEMO/OPA_SRC/OBS/obs_prep.F90	(revision 7713)
@@ -12,4 +12,8 @@
    !!   obs_pre_seaice : First level check and screening of sea ice observations
    !!   obs_pre_vel  : First level check and screening of velocity obs.
+   !!   obs_pre_logchl : First level check and screening of logchl obs.
+   !!   obs_pre_spm  : First level check and screening of spm obs.
+   !!   obs_pre_fco2 : First level check and screening of fco2 obs.
+   !!   obs_pre_pco2 : First level check and screening of pco2 obs.
    !!   obs_scr      : Basic screening of the observations
    !!   obs_coo_tim  : Compute number of time steps to the observation time
@@ -45,4 +49,8 @@
       & obs_pre_seaice, & ! First level check and screening of sea ice data
       & obs_pre_vel, &     ! First level check and screening of velocity profiles
+      & obs_pre_logchl, & ! First level check and screening of logchl data
+      & obs_pre_spm, &    ! First level check and screening of spm data
+      & obs_pre_fco2, &   ! First level check and screening of fco2 data
+      & obs_pre_pco2, &   ! First level check and screening of pco2 data
       & calc_month_len     ! Calculate the number of days in the months of a year  
 
